<?php
/*
 *Plugin Name: SmilePayC2C(UN-PAY)
 *Description: SmilePay 7-11 c2c Shipping
 * Version: 2.6.12
 * Author:  SmilePay
 * Author URI: http://www.smilepay.net
*/
 
/**
 * Check if WooCommerce is active
 */
if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
    add_action('plugins_loaded', 'smilepayc2cu_shipping_method_init', 0);

    add_action('woocommerce_checkout_update_order_review','Smilepayc2cup_shipping_method_match');
    add_action('before_woocommerce_pay','Smilepayc2cup_shipping_method_match_orderpay');

    //te覡LoIڤ覡
    function Smilepayc2cup_shipping_method_match()
    {

        global $smilepay_load_shipping_method;
        if ( WC()->cart->needs_shipping() ) {
           
            $packages = WC()->cart->get_shipping_packages();
      
            $smilepay_c2cup_service_id = WC_Smilepayc2cu_Shipping_Method::getSupport_Service();
            $payment_gateways = WC()->payment_gateways();
            if(!isset($smilepay_load_shipping_method) || $smilepay_load_shipping_method==false)
            {
                foreach ( $packages as $package_key => $package ) 
                {
                    WC()->shipping()->load_shipping_methods( $package );
           
                }
                $smilepay_load_shipping_method =TRUE;
            }
             
            $shipping_methods =  WC()->shipping()->shipping_methods;
            
            
            foreach($shipping_methods as $shipping_method)
            {
                 
               if(in_array($shipping_method->id,$smilepay_c2cup_service_id) && $shipping_method->get_instance_id() != 0)
               {
                   $smilepay_c2cup_shipping_method =  $shipping_method;
             
                   break;
               }
           
            }
            
            if( isset($smilepay_c2cup_shipping_method) &&  $smilepay_c2cup_shipping_method)
            {
                if($smilepay_c2cup_shipping_method->enabled!="yes")
                    return;
                if($smilepay_c2cup_shipping_method->instance_settings['payment_filter_enabled']!="yes")
                    return;
           
            }
        
            if(isset($_REQUEST['shipping_method'][0] ))
                $selected_shipping_method = $_REQUEST['shipping_method'][0] ;
            else
            {
                $chosen_methods = WC()->session->get( 'chosen_shipping_methods' );
                if(empty($chosen_methods))
                    return;
                $selected_shipping_method = $chosen_methods[0]; 
            }
                 

            foreach ( $payment_gateways as $payment_gateway ) {
                 foreach ( $payment_gateway as $gateway ) {
                        if( in_array(strtolower($selected_shipping_method),$smilepay_c2cup_service_id))
                        {
                            if(!in_array($gateway->id, $smilepay_c2cup_shipping_method->filter_payment) )
                                $gateway->enabled = 'no';
                          
                        }
                 }
            }
        }
      
    }
    //te覡LoIڤ覡 b
    function Smilepayc2cup_shipping_method_match_orderpay()
    {
        global $wp;

        if ( isset( $_GET['pay_for_order']) && $_GET['pay_for_order'] == 'true') 
        {
            $order_id = $wp->query_vars['order-pay'];
           
            if($order_id)
            {
                $order = wc_get_order( $order_id ); 
                if(!$order)
                    return;
                //$packages = WC()->cart->get_shipping_packages();
                
                //make fake package for find shipping region
                $packages = array();
                $packages[0]['destination']['country']   =  $order->shipping_country;
			    $packages[0]['destination']['state']     =  $order->shipping_state;
			    $packages[0]['destination']['postcode']  =  $order->shipping_postcode;
			    $packages[0]['destination']['city']      =  $order->shipping_city;
			    $packages[0]['destination']['address']   =  $order->shipping_address_1;
			    $packages[0]['destination']['address_2'] =  $order->shipping_address_2;

              
               
                //load shipping method
                foreach ( $packages as $package_key => $package ) 
                {
                     WC()->shipping()->load_shipping_methods( $package );
                }

              
                $shipping_methods =  WC()->shipping()->shipping_methods;
                $payment_gateways = WC()->payment_gateways();
                
                    
                foreach($shipping_methods as $shipping_method)
                {

                    if( $shipping_method->id == 'smilepay_711_c2c_shippingunpay' && $shipping_method->get_instance_id() != 0)
                    {
                        $smilepay_c2cup_shipping_method =  $shipping_method;
                        break;
                    }
                }

                if( isset($smilepay_c2cup_shipping_method) &&  $smilepay_c2cup_shipping_method)
                {
                    if($smilepay_c2cup_shipping_method->enabled!="yes")
                        return;
                    if($smilepay_c2cup_shipping_method->instance_settings['payment_filter_enabled']!="yes")
                        return;
                }
         
                $selected_shipping_method =    $order->has_shipping_method('smilepay_711_c2c_shippingunpay');

                
                foreach ( $payment_gateways as $payment_gateway ) {
                    foreach ( $payment_gateway as $gateway ) {
                        if($selected_shipping_method)
                        {
               
                             if(!in_array($gateway->id, $smilepay_c2cup_shipping_method->filter_payment) )
                                 $gateway->enabled = 'no';
                        }
                      

                    }
                }


            }
            else
                return;



        }
    }


	function  smilepayc2cu_shipping_method_init() {
		if ( ! class_exists( 'WC_Smilepayc2cu_Shipping_Method' ) ) {
            add_action('woocommerce_after_checkout_validation', 'WC_Smilepayc2cu_Shipping_Method::checkout_validate',10,1);
			class WC_Smilepayc2cu_Shipping_Method extends WC_Shipping_Method {
                const SMILEPAYC2CUP_METHOD_ID_711 = 'smilepay_711_c2c_shippingunpay';
                const SMILEPAYC2CUP_METHOD_ID_FAMI = 'smilepay_fami_c2c_shippingunpay';
                protected static $installed_hook=FALSE;
                private static $support_service = array(
                                                   '711' => self::SMILEPAYC2CUP_METHOD_ID_711,
                                                   'fami'=> self::SMILEPAYC2CUP_METHOD_ID_FAMI
                                                );
                protected static $smilepay_payzg_sub_tb = array(
                                                        '711' => '7NET',
                                                        'fami' => 'FAMI'
                                                    );

                private static $map_url = array(
                                                   '711' => array(
                                                                'mobile'=>'https://emap.presco.com.tw/c2cemapm-u.ashx?eshopid=870&servicetype=1&tempvar=%s&url=%s',
                                                                'normal'=>'https://emap.presco.com.tw/c2cemap.ashx?eshopid=870&servicetype=1&tempvar=%s&url=%s'
                                                            ),
                                                   'fami'=>  array(
                                                                'mobile'=>'https://ssl.smse.com.tw/api/LogisticsEmap.asp?TypesServer=FAMIC2C&TypesInterface=WEB&tempvar=%s&url=%s',
                                                                'normal'=>'https://ssl.smse.com.tw/api/LogisticsEmap.asp?TypesServer=FAMIC2C&TypesInterface=WEB&tempvar=%s&url=%s'
                                                            ),
                                                );
                protected static $service_cvs_name = array(
                                                        '711' => '7-11',
                                                        'fami' => 'a'
                                                    );
                protected static $service_cvs_query_shipment_url = array(
                                                                        '711' => 'https://eservice.7-11.com.tw/E-Tracking/search.aspx',
                                                                        'fami' => 'https://www.famiport.com.tw/Web_Famiport/page/process.aspx'
                                                                     
                                                                    );

                
				public function __construct($instance_id = 0) {
					$this->id                 = 'smilepay_711_c2c_shippingunpay';
					$this->method_title       = __( 'SmilePay CVStore Shipping(UN-PAY)' ); 

                    //for woocommerce 2.6 modify
					//$this->enabled            = "yes";
                    $this->instance_id 			 = absint( $instance_id );
                    $this->supports              = array(
			                                        'shipping-zones',
			                                        'instance-settings',
			                                        'instance-settings-modal',
		                                            );
                    $this->method_description    = u2bcu('Wӯ¨f');

                    $this->service_id   = array(
                                            '711' => self::SMILEPAYC2CUP_METHOD_ID_711,
                                            'fami' => self::SMILEPAYC2CUP_METHOD_ID_FAMI,
                                          );
					
                 
					$this->init();


                    $this->service_name   = array(
                                            '711' => $this->_711_title,
                                            'fami' => $this->fami_title
                                            );
                    if( empty($this->service_name['711']))
                        $this->service_name['711'] =u2bcu('tRt 7-11fI');

                    if( empty($this->service_name['fami']))
                        $this->service_name['fami'] =u2bcu('tRt afI');

                  
                    $this->title = u2bcu('tRt Wӯ¨f');
                    
                    $this->filter_payment = array(
                                            'smilepayatm',
                                            'smilepaycredit',
                                            'smilepaycredit_3',
                                            'smilepaycsv',
                                            'smilepayfamiport',
                                            'smilepayibon',
                                            'smilepayunion',
                                        );

				}

				public function init_form_fields() {  //x]m
					
					//for woocommerce 2.6 modify
					//$this->form_fields = array(
                    $this->instance_form_fields = array(
						/*'enabled' => array(
							'title' => __(u2bcu("ҥ/"), 'woocommerce'),
							'type' => 'checkbox',
							'default' => 'yes',
              'label' => __(u2bcu("SmilePay tRtWӯ¨f"), 'woocommerce'),
						),*/
                     array( 'title' => u2bcu('7-11¨f]w'), 'type' => 'title', 'id' => 'smilepayc2cup_711_title' ),
                        '711_enabled' => array(
							'title' =>  u2bcu("7-11Wӱҥ"),
                            'description' => u2bcu("}Ҧ\Ate覡|h@7-11¨fﶵ"),
							'type' => 'checkbox',
                            'css' => 'width:15px;',
							'default' => 'no',
                   			'label' => u2bcu("ҥ"),
						),	

                        '711_title' => array(
							'title' =>  u2bcu("te覡W(7-11)"),
                            'description' => u2bcu("exܪteW"),
							'type' => 'text',
							'default' => u2bcu('tRt 7-11Wӯ¨f'),
                   			'label' => u2bcu("exW(7-11)"),
						),	
                         'fee' => array(
							'title'       => u2bcu('O(7-11)'),
							'type'        => 'price',
							'description' => __( '', 'woocommerce' ),
							'default'     => '',
							'desc_tip'    => true,
							'placeholder' => wc_format_localized_price( 0 )
						),

                        array( 'title' => u2bcu('a¨f]w'), 'type' => 'title', 'id' => 'smilepayc2cup_fami_title' ),

                        'fami_enabled' => array(
							'title' =>  u2bcu("aWӱҥ"),
                            'description' =>u2bcu( "}Ҧ\Ate覡|h@ӥa¨fﶵ"),
							'type' => 'checkbox',
                            'css' => 'width:15px;',
							'default' => 'no',
                   			'label' => u2bcu("ҥ"),
						),	

                        'fami_title' => array(
							'title' =>  u2bcu("te覡W(a)"),
                            'description' => u2bcu("exܪteW"),
							'type' => 'text',
							'default' => u2bcu('tRt aWӯ¨f'),
                   			'label' =>u2bcu( "exW(a)"),
						),	
                         'fami_fee' => array(
							'title'       => u2bcu('O(a)'),
							'type'        => 'price',
							'description' => __( '', 'woocommerce' ),
							'default'     => '',
							'desc_tip'    => true,
							'placeholder' => wc_format_localized_price( 0 )
						),
                        array( 'title' => u2bcu('@q]w'), 'type' => 'title', 'id' => 'smilepayc2cup_title' ),
						'fee_top' => array(
							'title'       => __(u2bcu('KBOe'), 'woocommerce' ),
							'type'        => 'price',
							'description' => __(u2bcu("F즹BɡAKBOAϥνЫOť"), 'woocommerce'),
							'desc_tip'    => true,
							'placeholder' => wc_format_localized_price( 0 )
						),
                        'min_total' => array(
							'title'       => u2bcu('̧COB'),
							'type'        => 'price',
							'description' => u2bcu('qBF즹]wBA~iHϥΦte覡AtBO'),
							'default'     => '',
						),		
                        'payment_filter_enabled' => array(
							'title' =>  u2bcu("SmilePay te覡ftIڤ覡Wh"),
                            'description' => __(u2bcu("}Ҧ\AbbɡAte覡O¨fAIڤ覡utRtyҲ"), 'woocommerce'),
							'type' => 'checkbox',
							'default' => 'yes',
                   			'label' => u2bcu("ҥ"),
						),	
                      
                        /*'restric_categories' => array(
                                                'title'             => u2bcu('ӫ~O'),
				                                'type'              => 'multiselect',
				                                'class'             => 'wc-enhanced-select',
				                                'css'               => 'width: 400px;',
				                                'default'           => '',
				                                'description'       => u2bcu('Oӫ~iHϥΦte覡<br>hLctrlI<br>LctrlAIzwgQ<br>'),
				                                'options'           =>$this->get_all_categorys(),
				                                'custom_attributes' => array(
					                                'data-placeholder' => u2bcu('Oӫ~'),
				                            ),
                         ),	*/	
						'hiddtext' => array(
							'title' => __(u2bcu('Wӯ¨f`Nƶ'), 'woocommerce'),
							'type' => 'hidden',
							'description' => __(u2bcu("ϥζWӯ¨f\Aݪ`NHUƶG
														<br><font color='red'>ҲնȤ䴩SmilePaytRtyڨϥ</font>							
														<br>1.ХSmilePayӮax}Ҩf\*<a target='_blank' href='http://www.smilepay.net/RVG.ASP'>Ӯax</a>*
														<br>2.bT<font color='red'>pq</font><font color='red'>X</font>Aӫ~ɷ|H²TqC
														<br>3.O̦߭qAiSmilePayӮaxo<font color='red'>fKNX</font>C
														<br>4.O̦߭qAiܭqƵI<font color='red'>}úO</font>C														
														<br>5.бN<font color='red'>fKNX</font>ʷsWܰӫ~ƵAHQO̬dߪyAC
														<br>6.hаѾ\A<font color='red'>SmilePay</font>P<font color='red'>WooCommerceҲջ</font>C
														"), 'woocommerce'),
							'default' => __('', 'woocommerce')
						)         
					);
				}
 
				function init() {
					$this->init_form_fields(); 
					$this->init_settings();
					
                    $this->fee          = $this->get_option( 'fee' );
                    $this->fami_fee          = $this->get_option( 'fami_fee' );

                    $this->_711_enabled = $this->get_option( '711_enabled' );
                    $this->fami_enabled = $this->get_option( 'fami_enabled' );
                    

                    $this->_711_title = $this->get_option( '711_title' );
                    $this->fami_title = $this->get_option( 'fami_title' );

                    //$this->restric_categories = $this->get_option('restric_categories');

					$this->fee_top= $this->get_option( 'fee_top' );					
                    $this->min_total =$this->get_option('min_total');
                    $this->payment_filter_enabled= $this->get_option( 'payment_filter_enabled' );
                   
                    add_action( 'woocommerce_update_options_shipping_' . $this->id, array( $this, 'process_admin_options' ) );
					
				}
                static function checkout_validate( $data )
                {
                   //$shipping_methods =$data['shipping_method'];
                   if ( WC()->cart->needs_shipping() ) {
                        $chosen_shipping_methods = WC()->session->get( 'chosen_shipping_methods' );
                        $chosen_payment_method = WC()->session->get( 'chosen_payment_method' ); 
                        $find_shipping_method=FALSE;
                        foreach($chosen_shipping_methods as $shipping_method)
                        {
                            if(self::isSupport_Service($shipping_method))
                            {
                                $find_shipping_method=TRUE;
                            }
                        }
                        if( $find_shipping_method)
                        {
                        
                            $username=$data['billing_first_name'].$data['billing_last_name'];
                            if( !preg_match("/[^a-zA-Z0-9 ]/",$username))
                            {
                                $limit_name_number =10;
                            }
                            else
                            {
                                $limit_name_number =5;
                            }
				            if(substr($data['billing_phone'],0,2)!="09"||mb_strlen($data['billing_phone'])!=10||mb_strlen( $username, "utf-8")>$limit_name_number){
                               wc_add_notice( u2bcu("<br>qܮ榡~Ad09XX123456(@10X)C<br>O̩mWiWL5ӦrA­^hiWL10ӦrCЦAT{C<br>"),'error');
                   
				            }
                            $filter_payment = array(
                                            'smilepayatm',
                                            'smilepaycredit',
                                            'smilepaycredit_3',
                                            'smilepaycsv',
                                            'smilepayfamiport',
                                            'smilepayibon',
                                            'smilepayunion',
                                        );
                            if(!in_array($chosen_payment_method,$filter_payment) )
                            {
                               wc_add_notice( u2bcu("<br>Iڤ覡ܿ~Ate覡iӥIڤ覡AЧ󴫨@<br>",'error'));
                            }
                        }
                   }
                }
 
				/**
				 * calculate_shipping function.
				 *
				 * @access public
				 * @param mixed $package
				 * @return void
				 */
				public function calculate_shipping( $package = array() ) {
					$shipping_total=0;
					$fee_top=$this->fee_top;
					$total = WC()->cart->cart_contents_total;		
                    
                    /*if($this->restric_categories)
                    {
                       //foreach ( $package as  $package_items ) 
                       if(isset($package['contents']))
                       {
                           foreach ( $package['contents'] as $package_item ) 
                           {
                               $product_categories =$package_item['data']->get_category_ids();
                               foreach($product_categories as $product_categories_id)
                               {
                                   if(in_array($product_categories_id,$this->restric_categories))
                                    return FALSE;
                               }
                           }
                       }              
                    }	*/

                    if($this->_711_enabled == "yes")
                    {
                        $shipping_total=$this->fee;	
                        //if(isset($outside_fee))
                         //   $shipping_total += $outside_fee;
					    if($total>=$fee_top AND $fee_top<>0 AND $fee_top<>NULL)
					    {$shipping_total=0;}
                        $rate = array(
						    'id' => $this->service_id['711'],
						    'label' =>$this->service_name['711'],
						    'cost' => $shipping_total
					    );
                        // Register the rate
                        if($total >= $this->min_total)
                            $this->add_rate( $rate );
                    }
                    
                    if($this->fami_enabled == "yes")
                    {
                        $shipping_total=$this->fami_fee;	
                        //if(isset($outside_fee))
                         //   $shipping_total += $outside_fee;
					    if($total>=$fee_top AND $fee_top<>0 AND $fee_top<>NULL)
					    {$shipping_total=0;}
                        $rate = array(
						    'id' => $this->service_id['fami'],
						    'label' =>$this->service_name['fami'],
						    'cost' => $shipping_total
					    );
                        // Register the rate
                        if($total >= $this->min_total)
                            $this->add_rate( $rate );
                    }
				}
                // O_C2CUPBe
                // $order_id:qs
                public function isSelectedSmilepayC2Cup($order_id)
                {
                 
                    if(!isset($order_id) || empty($order_id))
                    {
                        return false;
                    }
            
                    $order = new WC_Order($order_id);
          
                    if(!isset($order) || empty($order))
                        return false;

                    if(is_admin())
                    {
                        $shipping_methods = $order->get_shipping_methods();
		                $has_method = false;

		                if ( empty( $shipping_methods ) ) {
			                return false;
		                }
                         

		                foreach ( $shipping_methods as $shipping_method ) {

                            foreach($shipping_method['item_meta_array'] as $shipping_method_i  )
                            {
                                if ( $shipping_method_i->key == 'method_id' && in_array($shipping_method_i->value,$this->service_id)  ) {
                                
				                    return true;
			                    }   
                            }
			                
		                }
                        return FALSE;

                    }
                    else
                    {

                        foreach($this->service_id as $service_id) 
                        {
                           if( $order->has_shipping_method($service_id ))
                            return true; 
                        }
                        return false;
                    }
                 }
                 public static function isSupport_Service($method_id)
                 {
                     if(in_array($method_id,self::$support_service))
                        return TRUE;
                     return FALSE;
                 } 
                 public static function getSupport_Service()
                 {
                     return self::$support_service;
                 }
                 public static function getCSVServiceArg($method_id)
                 {
                     foreach(self::$support_service as $key => $val)
                     {
                         if( $val == $method_id)
                            return self::$smilepay_payzg_sub_tb[$key];
                     }
                     return FALSE;
                 }
                 public static function getCSVServiceName($method_id)
                 {
                     foreach(self::$support_service as $key => $val)
                     {
                         if( $val == $method_id)
                            return u2bcu(self::$service_cvs_name[$key]);
                     }
                     return FALSE;
                 }
                 
                 public static function getQueryShipmentUrl($method_id)
                 {
                     foreach(self::$support_service as $key => $val)
                     {
                         if( $val == $method_id)
                            return self::$service_cvs_query_shipment_url[$key];
                     }
                     return FALSE;
                 }

                 //emap url
                 public static function getCSVMapUrl($method_id,$ret_url,$note='')
                 {
                     $useragent=$_SERVER['HTTP_USER_AGENT'];
                     foreach(self::$support_service as $key => $val)
                     {
                         if( $val == $method_id)
                         {
                            if(!isset(self::$map_url[$key]))
                                continue;
                            else
                            {
                                
                                if( preg_match('/Android|iPad|iPhone/i',$useragent)  )
                                {
                                    return sprintf(self::$map_url[$key]['mobile'],$note,urlencode($ret_url));
                                }
                                else
                                {
                                    return sprintf(self::$map_url[$key]['normal'],$note,urlencode($ret_url));
                                }
                            }
                         }
                           
                     }
                   
                     return '';
                     
                 }
                 public function get_all_categorys()
                 {
                     $args = array(
                               'hierarchical' => 1,
                               'show_option_none' => '',
                               'hide_empty' => 0,
                               'taxonomy' => 'product_cat'
                           );
                     $subcats = get_categories($args);
                     $ret_arr=array();
                     foreach ($subcats as $sc) {
                             $ret_arr[$sc->term_id] = $sc->name;
                     }
                     return $ret_arr;
                 }
 
			}
		}
        if(is_admin())
        {
            global $pagenow;
            add_action('admin_notices', 'smilepay_c2cup_shipping_error_show' );
            if($pagenow=='post.php' && $_GET['Page']=='smilepay_c2cup_shipping_gen')
            {
                smilepay_c2cup_shipping_gen();
            }
        }
	}

  
	add_action( 'woocommerce_shipping_init', 'smilepayc2cu_shipping_method_init' );
 
	function add_smilepayc2cu_shipping_method( $methods ) {

        //for woocommerce 2.6 modify
		$methods['smilepay_711_c2c_shippingunpay'] = 'WC_Smilepayc2cu_Shipping_Method';
       
		return $methods;
	}

    
    function smilepay_c2cup_shipping_error_show()
    {
        $error= $_COOKIE['smilepay_c2cup_admin_shipping_error'];
        if(isset($_COOKIE['smilepay_c2cup_admin_shipping_error']))
        {
             unset($_COOKIE['smilepay_c2cup_admin_shipping_error']);
             setcookie('smilepay_c2cup_admin_shipping_error', '', time() - 30 );
        }
            
        if($error)
        {
            echo "<div class='notice notice-error'><p>$error</p></div>";
        }

    }

    function smilepay_c2cup_shipping_gen()
    {
        if(
            !isset($_GET['smseid'])  || !$_GET['smseid'] ||
            !isset($_GET['dcvc'])  || !$_GET['dcvc'] ||
            !isset($_GET['Verify_key'])  || !$_GET['Verify_key'] ||
            !isset($_GET['order_id'])  || !$_GET['order_id'] 
        )
        {
            setcookie("smilepay_c2cup_admin_shipping_error",  u2bcu("~,Ѽƿ~"), time()+30);
            wp_redirect($order_url);
            exit;
        }

        $order_id = $_GET['order_id'];
        $order_url =  get_admin_url()."post.php?post=$order_id&action=edit";
       
       // if(!class_exists('WC_Smilepayc2cu_Shipping_Method'))
         //   smilepayc2cu_shipping_method_init();
        $smilepayc2cup_obj=new WC_Smilepayc2cu_Shipping_Method();
        if(! $smilepayc2cup_obj->isSelectedSmilepayC2Cup($order_id))
        {
          
            setcookie("smilepay_c2cup_admin_shipping_error",  u2bcu("~,ӭq"), time()+30);
            wp_redirect($order_url);
            exit;
            
        }
        $order = new WC_Order($order_id);
        $cccurl="https://ssl.smse.com.tw/api/C2CPaymentU.asp";
        $postdata="types=xml&smseid=".$_GET['smseid']."&dcvc=".$_GET['dcvc']."&Verify_key=".$_GET['Verify_key'];
        $shipping_method = @array_shift($order->get_shipping_methods());

        foreach($shipping_method['item_meta_array']  as $items)
        {
             
            if($items->key=='method_id')
            {
                $shipping_method_id = $items->value;
                break;
            }

        }
        if(class_exists('WC_Smilepayc2cu_Shipping_Method'))
        {
            $methods_arg= WC_Smilepayc2cu_Shipping_Method::getCSVServiceArg($shipping_method_id);
            if($methods_arg)
            {
                $postdata .= "&Pay_subzg=".$methods_arg;
            }
        }
        
        $ch1 = curl_init();
	    curl_setopt($ch1, CURLOPT_URL, $cccurl);
	    curl_setopt($ch1, CURLOPT_VERBOSE, 1);
	    curl_setopt($ch1, CURLOPT_SSL_VERIFYPEER, FALSE);
	    curl_setopt($ch1, CURLOPT_SSL_VERIFYHOST, FALSE);
	    curl_setopt($ch1, CURLOPT_POST, 1);
	    curl_setopt($ch1, CURLOPT_RETURNTRANSFER, 1);
	    curl_setopt($ch1, CURLOPT_POSTFIELDS, $postdata);
	    $string_1 = curl_exec($ch1);
	    curl_close($ch1);
	    $xmls = simplexml_load_string($string_1);
	    $Status_1 = $xmls->Status;

        if( empty($xmls))
        {
            setcookie("smilepay_c2cup_admin_shipping_error", u2bcu("~"), time()+30);
            wp_redirect($order_url);
            exit;
        }

	    if($Status_1=="1")
	    {
             

             $notes=$order->get_customer_order_notes();
             $queryShipmentUrl = WC_Smilepayc2cu_Shipping_Method::getQueryShipmentUrl($shipping_method_id);


             $comment = u2bcu("fKXG".$xmls->paymentno . $xmls->validationno."<br>*<a target='_blank' href='$queryShipmentUrl'>d߭</a>*");
          
             foreach($notes as $note)
             {
                 if($note->comment_content == $comment)
                 {    
                    setcookie("smilepay_c2cup_admin_shipping_error", u2bcu("wg͸ӳƵ"), time()+30);
                    wp_redirect($order_url);
                    exit;
                   
                 }
                   

             }
           
             $order->add_order_note($comment,"1");
             //do_action( 'smilepay_c2c_shippingunpay_create_shipping_trick',$order_id, $xmls->paymentno . $xmls->validationno, $_GET['smseid'] );
             wp_redirect($order_url);
             exit;
        }
        else
        {
            setcookie("smilepay_c2cup_admin_shipping_error", u2bcu(sprintf("~,~NX:%s,",$xmls->Status)), time()+30);
            wp_redirect($order_url);
            exit;
        }
        
        
      
    }
	add_filter( 'woocommerce_shipping_methods', 'add_smilepayc2cu_shipping_method' );
}


   



function u2bcu($text)//eX
{	return iconv("big5","UTF-8",$text);}
function b2ucu($text)//gJƮw
{	return iconv("UTF-8","big5",$text);}
